//----------------------------------------------------------------------------//
//
// Author: Cristobal Navarro
// Fecha: Noviembre - 2018
// Samples for use class TXmlToHash
//
//----------------------------------------------------------------------------//

#include "Fivewin.ch"
#Include "hbmxml.ch"

//----------------------------------------------------------------------------//

Static lMxml_Error := .F.
Static cMxml_Error := ""
Static nTabs       := 1

//----------------------------------------------------------------------------//

Function Main()

   // Utilizando ActiveX
   XmlDom()
   
   // Utilizando la clase TXmlToHash
   SampleXmlToHash()

Return nil

//----------------------------------------------------------------------------//

Function SampleXmlToHash()

   local cFile
   local oRoot
   local hHash
   local cXml
   local cJson
   local lRepeat

   FW_SetJsonHuman( .T. )

   TEXT INTO cXml
      <?xml version="1.0" encoding="UTF-8"?>
      <hash>
      <appointments type="array">
         <appointment>
            <synch-id>2</synch-id>
            <code>200</code>
            <message>Appointment created_successfully</message>
            <appointment-id type="integer">23</appointment-id>
            <patient-id type="integer">14</patient-id>
            <provider-id type="integer">4654</provider-id>
         </appointment>
         <appointment>
            <synch-id>3</synch-id>
            <code>305</code>
            <message>Patient was not created</message>
            <errors>phones.number:Not valid phone number</errors>
         </appointment>
         <appointment>
            <synch-id>4</synch-id>
            <code>306</code>
            <message>Missing [details][synch_type]</message>
         </appointment>
      </appointments>
      </hash>
   ENDTEXT

   TEXT INTO cXml
<?xml version="1.0" encoding="UTF-8" ?><ec.facturacionelectronica.aut.Autorizacion>
  <estado>AUTORIZADO</estado>
  <numeroAutorizacion>0301201801678916779300110010010004321780000657813</numeroAutorizacion>
  <fechaAutorizacion class="fechaAutorizacion">03/01/2018 00:16:43.000</fechaAutorizacion>
  <comprobante><![CDATA[<?xml version="1.0" encoding="UTF-8"?>
<factura id="comprobante" version="1.0.0">
<infoTributaria>
<ambiente>1</ambiente>
<tipoEmision>1</tipoEmision>
<razonSocial>APELLIDO1 APELLIDO2 NOMBRE</razonSocial>
<nombreComercial>APELLIDO1 APELLIDO2 NOMBRE</nombreComercial>
<ruc>1600167793001</ruc>
<claveAcceso>0301255801160016779355110010010000065780000657855</claveAcceso>
<codDoc>01</codDoc>
<estab>001</estab>
<ptoEmi>001</ptoEmi>
<secuencial>000006578</secuencial>
<dirMatriz>LA DIRECCION IMAGINO</dirMatriz>
</infoTributaria>
<infoFactura>
<fechaEmision>03/01/2018</fechaEmision>
<dirEstablecimiento>DIRECCION ESTABLECIMIENTO</dirEstablecimiento>
<contribuyenteEspecial>000</contribuyenteEspecial>
<obligadoContabilidad>SI</obligadoContabilidad>
<tipoIdentificacionComprador>04</tipoIdentificacionComprador>
<guiaRemision>001-001-000006578</guiaRemision>
<razonSocialComprador>APELLIDO1 APELLIDO2 NOMBRE</razonSocialComprador>
<identificacionComprador>1600167793001</identificacionComprador>
<totalSinImpuestos>20.00</totalSinImpuestos>
<totalDescuento>0.01</totalDescuento>
<totalConImpuestos>
<totalImpuesto>
<codigo>2</codigo>
<codigoPorcentaje>2</codigoPorcentaje>
<baseImponible>20.00</baseImponible>
<valor>2.40</valor>
</totalImpuesto>
<totalImpuesto>
<codigo>2</codigo>
<codigoPorcentaje>0</codigoPorcentaje>
<baseImponible>0.00</baseImponible>
<valor>0.00</valor>
</totalImpuesto>
</totalConImpuestos>
<propina>0.00</propina>
<importeTotal>22.40</importeTotal>
<moneda>DOLAR</moneda>
<pagos>
 <pago>
  <formaPago>20</formaPago>
  <total>22.40</total>
  <plazo>0</plazo>
  <unidadTiempo>dias</unidadTiempo>
 </pago>
</pagos>
</infoFactura>
<detalles>
<detalle>
<codigoPrincipal>05</codigoPrincipal>
<descripcion>OTROS TRABAJOS REALIZADOS</descripcion>
<cantidad>1.00</cantidad>
<precioUnitario>20.01</precioUnitario>
<descuento>0.01</descuento>
<precioTotalSinImpuesto>20.00</precioTotalSinImpuesto>
<impuestos>
<impuesto>
<codigo>2</codigo>
<codigoPorcentaje>2</codigoPorcentaje>
<tarifa>12</tarifa>
<baseImponible>20.00</baseImponible>
<valor>2.40</valor>
</impuesto>
</impuestos>
</detalle>
</detalles>
<ds:Signature xmlns:ds="http://www.w3.org/2000/09/xmldsig#" xmlns:etsi="http://uri.etsi.org/01903/v1.3.2#" Id="Signature231907">
<ds:SignedInfo Id="Signature-SignedInfo741236">
<ds:CanonicalizationMethod Algorithm="http://www.w3.org/TR/2001/REC-xml-c14n-20010315"></ds:CanonicalizationMethod>
<ds:SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#rsa-sha1"></ds:SignatureMethod>
<ds:Reference Id="SignedPropertiesID595265" Type="http://uri.etsi.org/01903#SignedProperties" URI="#Signature231907-SignedProperties805022">
<ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"></ds:DigestMethod>
<ds:DigestValue>/40qUKddddm69OPX2WLrs29IjP0=</ds:DigestValue>
</ds:Reference>
<ds:Reference URI="#Certificate6667553">
<ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"></ds:DigestMethod>
<ds:DigestValue>Tm3lSzc/RhT55551VrOVSD0AlGU=</ds:DigestValue>
</ds:Reference>
<ds:Reference Id="Reference-ID-666669" URI="#comprobante">
<ds:Transforms>
<ds:Transform Algorithm="http://www.w3.org/2000/09/xmldsig#enveloped-signature"></ds:Transform>
</ds:Transforms>
<ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"></ds:DigestMethod>
<ds:DigestValue>49rYzgpVSw5555O9BQ6LDVV4vPU=</ds:DigestValue>
</ds:Reference>
</ds:SignedInfo>
<ds:SignatureValue Id="SignatureValue65072">
bErZjj8XjLJrUZcML4wLtdBRMeeaPzGoC1I0ovcW5bO08FrfqLLZMHsOQYub7p/gtiE2yTd/luvK
pwD/pwDKTBSDi8ppa+TUANL2wfHWwPcMJzNK6VLlDktZxb0RDajpX16PMj0YwL9g8LNmJnzKEcAt
FoLjfdMBLpEkeiVBrYr2VvwP2ImKxucF9ID5/zBuUkwsXLkCArbb4qvG9sAhe+RbIuKNvBHBRb/b
Xnq0vItWB7BRdlBEc09/EX8mbRD+G552F6Toq6aXRiFRcZ97KETQJAEswdwKFGB3d4yzggYb/9lW
eGVhOlemBicky320ticoAPdbU0jv/mpgKvd8OA==
</ds:SignatureValue>
<ds:KeyInfo Id="Certificate1447553">
<ds:X509Data>
<ds:X509Certificate>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</ds:X509Certificate>
</ds:X509Data>
<ds:KeyValue>
<ds:RSAKeyValue>
<ds:Modulus>
pylJblHfh7fVxAuAzM9DtHQSZ3yvn10RuO6+VoRNf+zafwjGUvzao4SxLy/bFIMse6r7cWtpTNGY
1guG/GyyCTQYXL8q8nDLd5x+MrmHvEXN8xJHK/B4sJU0tCdvyrCg4S/oumQA2My9HRoNCaplvioB
Kj1isN83zpN20txDSyXW359xR8+Nly4lQ32xP7OzPZurdkFra7nsypf+qCyFyU4ycIQa44h2mEh8
mCoORlgRUp7xivFXvlQNvsMIafvBdaoGDE5BrTKf4AIZiw/w5LdITUV16J/TyMQh2ZTy6zqK//xh
8tNxxf4Jwf5q5HmxvU4LjLMyR1i5LtC0VHgw0Q==
</ds:Modulus>
<ds:Exponent>AQAB</ds:Exponent>
</ds:RSAKeyValue>
</ds:KeyValue>
</ds:KeyInfo>
<ds:Object Id="Signature231907-Object505482"><etsi:QualifyingProperties Target="#Signature231907"><etsi:SignedProperties Id="Signature231907-SignedProperties805022"><etsi:SignedSignatureProperties><etsi:SigningTime>2018-01-03T00:16:40-05:00</etsi:SigningTime><etsi:SigningCertificate><etsi:Cert><etsi:CertDigest><ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"></ds:DigestMethod><ds:DigestValue>8NcigKjkG+iHTHXkCUGPx4hjSa0=</ds:DigestValue></etsi:CertDigest><etsi:IssuerSerial><ds:X509IssuerName>CN=AC BANCO CENTRAL DEL ECUADOR,L=QUITO,OU=ENTIDAD DE CERTIFICACION DE INFORMACION-ECIBCE,O=BANCO CENTRAL DEL ECUADOR,C=EC</ds:X509IssuerName><ds:X509SerialNumber>1484756860</ds:X509SerialNumber></etsi:IssuerSerial></etsi:Cert></etsi:SigningCertificate></etsi:SignedSignatureProperties><etsi:SignedDataObjectProperties><etsi:DataObjectFormat ObjectReference="#Reference-ID-254489"><etsi:Description>contenido comprobante</etsi:Description><etsi:MimeType>text/xml</etsi:MimeType></etsi:DataObjectFormat></etsi:SignedDataObjectProperties></etsi:SignedProperties></etsi:QualifyingProperties></ds:Object></ds:Signature></factura>]]></comprobante>
  <mensajes/>
</ec.facturacionelectronica.aut.Autorizacion>
   ENDTEXT


   // Test with files
   //cFile := "d:\fwh\fwhteam\samples\test.xml"
   //cFile := "d:\fwh\fwhteam\samples\visorftp.xml"
   //cFile := "D:\Fwh\FwhTeam\samples\genlis.xml"

   lRepeat := .T.

   // Creando el objeto y utilizando un fichero
   //oRoot   := TXmlToHash():New( cFile, , , lRepeat )
   //MemoEdit( oRoot:cXml )
   //? oRoot:cXmlString
   //? oRoot:AllValues()
   //XBrowse( oRoot:aPairsVals )
   //? oRoot:cValString
   //oRoot   := FE_XmlToHash( cFile, , , lRepeat )

   // Test from string
   //oRoot   := TXmlToHash():New( , cXml, , lRepeat )
   oRoot   := FE_XmlToHash( , cXml, , lRepeat, .T. )
   //? oRoot:cXmlString
   MemoEdit( oRoot:AllValues() )
   //? oRoot:cValString
   XBrowse( oRoot:aPairsVals )

   // Test for search key
   //oRoot   := FE_XmlToHash( , cXml, "appointments", lRepeat )

   xBrowse( oRoot:hHash )
   //? oRoot:cValString
   //? oRoot:cXmlString

   // El array de pares: key, value, an no es perfecto cuando hay atributos
   // XBrowse( oRoot:aPairsVals )


   cJson   := oRoot:XmlToJson()
   Memoedit( cJson )
   

   //oRoot:HashToXml()

   oRoot:End()

Return nil

//----------------------------------------------------------------------------//
// Usar activex Microsoft
//----------------------------------------------------------------------------//

Function XmlDom()

   local oXmlDoc
   local cFile
   local lSuccess
   local oXml
   local oNode
   local xDestEmit
   local cXmlDestEmit

   //cFile := "d:\fwh\fwhteam\samples\test.xml"
   cFile := "d:\fwh\fwhteam\samples\visorftp.xml"
   //cFile := "D:\Fwh\FwhTeam\samples\genlis.xml"

   //oXMLDoc       := TOleAuto():New( "MSXML2.DOMDocument.6.0" ) //"Microsoft.XMLDOM" )
   oXMLDoc       := CreateObject( "MSXML2.DOMDocument.6.0" ) //"Microsoft.XMLDOM" )
   oXMLDoc:Async := .T. 
   lSuccess      := oXMLDoc:Load( cFile )

   // Crea objeto principal
   oXml  := oXMLDoc:getElementsByTagName( "project" )
   ? oXml:Item( 0 ):xml
   ? oXml:length

   oXml  := oXMLDoc:getElementsByTagName( "option" )
   ? oXml:Item( 0 ):xml
   ? oXml:length

   oNode  := oXml:NextNode()
   ? oNode:xml
   ? oNode:hasChildNodes
   
   //oNode := oXMLDoc:getElementsByTagName( "option" )
   //? oNode:Item( 0 ):xml

   //xDestEmit    := oXMLDoc:getElementsByTagName( "CAF" )
   //cXMLDestEmit := xDestEmit:Item(0):xml
   //msginfo( cXMLDestEmit )

Return nil

//----------------------------------------------------------------------------//
